.\"=====================================================================
.\" This file should contain NO tabs.  It must be formatted by
.\"      pic epsutil.man | tbl | [nt]roff -man
.\" or
.\"      gpic epsutil.man | gtbl | groff -man
.\" ====================================================================
.\"  @Troff-man-file{
.\"     author          = "Nelson H. F. Beebe",
.\"     version         = "2.03",
.\"     date            = "23 February 2004",
.\"     time            = "11:30:12 MST",
.\"     filename        = "epsutil.man",
.\"     address         = "Center for Scientific Computing
.\"                        University of Utah
.\"                        Department of Mathematics, 322 INSCC
.\"                        155 S 1400 E RM 233
.\"                        Salt Lake City, UT 84112-0090
.\"                        USA",
.\"     telephone       = "+1 801 581 5254",
.\"     FAX             = "+1 801 585 1640, +1 801 581 4148",
.\"     URL             = "http://www.math.utah.edu/~beebe",
.\"     checksum        = "34115 1887 7569 49228",
.\"     email           = "beebe@math.utah.edu, beebe@acm.org,
.\"                        beebe@computer.org, beebe@ieee.org
.\"                        (Internet)",
.\"     codesource      = "ftp://ftp.math.utah.edu/pub/misc/index.html#epsutil-2.03",
.\"     codetable       = "ISO/ASCII",
.\"     keywords        = "background; bounding box; BoundingBox;
.\"                        clipping; color; EPS; Encapsulated
.\"                        PostScript; framing; landscape; linewidth;
.\"                        magnification; portrait; PostScript utility;
.\"                        rotation; scaling; translation",
.\"     supported       = "yes",
.\"     docstring       = "This file is the UNIX nroff/troff manual page
.\"                        documentation for epsutil, a utility for
.\"                        manipulating Encapsulated PostScript files.
.\"
.\"                        The checksum field above contains a CRC-16
.\"                        checksum as the first value, followed by the
.\"                        equivalent of the standard UNIX wc (word
.\"                        count) utility output of lines, words, and
.\"                        characters.  This is produced by Robert
.\"                        Solovay's checksum utility.",
.\"  }
.\" ====================================================================
.TH EPSUTIL 1 "23 February 2004" "Version 2.03"
.\"===============================================
.if t .ds Ps P\s-2OST\s+2S\s-2CRIPT\s+2
.if n .ds Ps PostScript
.if t .ds Te T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Te TeX
.if t \{
.\" Define .PS and .PE as in -me package, for centered pictures.
.de PS
.sp 0.3
.nr g7 \\$2
.in (\\n(.lu-\\n(g7u)/2u
.ne \\$1u
.nr g7 \\n(.u
.ls 1
..
.de PE
.ls
.in
.if \\n(g7 .fi
.sp .6
..
\}
.hw Bounding-Box BOUNDING-BOX Page-Height
.hw Page-Width Post-Script effect-ively
.hw hex-a-dec-i-mal other-wise trans-form-ation
.SH NAME
epsutil \- a utility for manipulating Encapsulated PostScript files
.\"===============================================
.SH SYNOPSIS
.na
.B epsutil
.BI "[\ BG" =color-value "\ ]"
.if n .ti +8n
.BI "[\ BOUNDINGBOX" =llx,lly,urx,ury "\ ]"
.if n .ti +8n
.BI "[\ CHECK" =check "\ ]"
.if n .ti +8n
.BI "[\ CLIP" =clip "\ ]"
.if t .ti +.5i
.if n .ti +8n
.BI "[\ COLORMODEL" =[CMYK\||\|GRAY\||\|HSB\||\|RGB\||\|X] "\ ]"
.if t .ti +.5i
.if n .ti +8n
.BI "[\ FG" =color-value "\ ]"
.if n .ti +8n
.BI "[\ FRAME" =frame-thickness "\ ]"
.if n .ti +8n
.BI "[\ FRAMEFG" =color-value "\ ]"
.if t .ti +.5i
.BI "[\ GRID" =grid "\ ]"
.if n .ti +8n
.if t .ti +.5i
.BI "[\ GRIDX" "=xmin,dx,xmax,units,gridstep,tickstep,ticklength,thickmultiple,fontname,fontsize" "\ ]"
.if n .ti +8n
.if t .ti +.5i
.BI "[\ GRIDY" "=ymin,dy,ymax,units,gridstep,tickstep,ticklength,thickmultiple,fontname,fontsize" "\ ]"
.if t .ti +.5i
.if n .ti +8n
.BI "[\ HEIGHT" =height "\ ]"
.if n .ti +8n
.if t .ti +.5i
.BI "[\ ID" =idx,idy[,fontsize[,fontname]] "\ ]"
.if n .ti +8n
.BI "[\ IDBG" =color-value "\ ]"
.BI "[\ IDFG" =color-value "\ ]"
.if t .ti +.5i
.if n .ti +8n
.BI "[\ LINEWIDTHSCALE" =line-width-scale "\ ]"
.if n .ti +8n
.if t .ti +.5i
.BI "[\ MAXLINEWIDTH" =maximum-line-width "\ ]"
.if n .ti +8n
.BI "[\ MINLINEWIDTH" =minimum-line-width "\ ]"
.if t .ti +.5i
.if n .ti +8n
.BI "[\ MXY" =page-magnification "\ ]"
.if n .ti +8n
.BI "[\ MX" =page-x-magnification "\ ]"
.if n .ti +8n
.BI "[\ MY" =page-y-magnification "\ ]"
.if t .ti +.5i
.if n .ti +8n
.BI "[\ OXY" =origin "\ ]"
.BI "[\ OX" =llx-origin "\ ]"
.BI "[\ OY" =lly-origin "\ ]"
.if n .ti +8n
.BI "[\ PAPER" =paper-name "\ ]"
.if n .ti +8n
.if t .ti +.5i
.BI "[\ PSCODE" "='\*(Ps\& code'" "\ ]"
.if n .ti +8n
.BI "[\ PSFILE" =psfile,psfile,.\|.\|. "\ ]"
.if n .ti +8n
.BI "[\ PAGEBG" =color-value "\ ]"
.if t .ti +.5i
.if n .ti +8n
.BI "[\ PMXY" =page-magnification-x-and-y-origin "\ ]"
.if t .ti +.5i
.if n .ti +8n
.BI "[\ PMX" =page-magnification-x-origin "\ ]"
.if n .ti +8n
.BI "[\ PMY" =page-magnification-y-origin "\ ]"
.if t .ti +.5i
.if n .ti +8n
.BI "[\ PTXY" =page-translation-x-and-y "\ ]"
.if n .ti +8n
.BI "[\ PTX" =page-translation-x "\ ]"
.if n .ti +8n
.BI "[\ PTY" =page-translation-y "\ ]"
.if t .ti +.5i
.if n .ti +8n
.BI "[\ RGBFILE" =rgbfile "\ ]"
.BI "[\ ROTATE" =degrees "\ ]"
.if n .ti +8n
.if t .ti +.5i
.BI "[\ SXY" =scale-factor "\ ]"
.if n .ti +8n
.BI "[\ SX" =x-scale-factor "\ ]"
.BI "[\ SY" =y-scale-factor "\ ]"
.if n .ti +8n
.BI "[\ WIDTH" =width "\ ]"
.if n .ti +8n
.if t .ti +.5i
.BI  "[\ <\ ] " old-PS-file "\ \ \ >\ " new-PS-file
.ad
.\"===============================================
.SH DESCRIPTION
.B epsutil
filters an Encapsulated \*(Ps\& file, or files,
named on the command line (or
.I stdin
if
no filenames are given), to
.IR stdout ,
inserting wrapper \*(Ps\& to provide optionally
.RS
.TP \w'\(bu'u+1n
\(bu
background, foreground, frame, label, and page colors,
.TP
\(bu
BoundingBox adjustment and measurement,
.TP
\(bu
checking for non-EPS operators,
.TP
\(bu
clipping,
.TP
\(bu
framing,
.TP
\(bu
image rotation, scaling, and translation,
.TP
\(bu
linewidth scaling,
.TP
\(bu
page magnification and translation, and
.TP
\(bu
\*(Ps\& alteration.
.RE
.PP
The output file fully conforms to the
.I "\*(Ps\& Document Structuring Conventions"
defined in Appendix G of the
.IR "\*(Ps\& Language Reference Manual" ,
Second Edition, Addison-Wesley (1985), ISBN
0-201-10174-2 (the Adobe red book).
.PP
The output of this program is also suitable input
to it; after four filtering steps with 90-degree
rotation selected, the original figure will be
recovered, although the output \*(Ps\& file will
be about 6200 bytes larger for each rotation
because of the wrapper overhead.  That overhead
could be reduced to about 4100 bytes by
eliminating extra spaces and comments beginning
with a single percent; readability is, however,
considered more important.
.PP
The original command line that was used to create
the output file is preserved in a
.I %%Title
comment in the second line of the output file, as
a record of the requested transformations.
.PP
A verbatim copy of the original file, minus any
.I %%EOF
comments, is embedded in the output between the
.I %%BeginDocument
and
.I %%EndDocument
lines, where it can be recovered simply by
stripping the wrapping \*(Ps\&.
.\"===============================================
.SH OPTIONS
.B epsutil
options take the form of
.BI NAME =value
assignments, rather than the more usual
hyphen-prefixed options common in other UNIX
utilities.  If an option is given more than once,
its
.I last
assigned value is used.
.PP
If no dimension unit is specified in the variable
values described later, physical dimensions are
assumed to be measured in standard \*(Ps\& units
of big points:
.PP
        72bp = 1in = 25.4mm
.PP
Otherwise, any of the \*(Te\& dimension units of
.I bp
(big point),
.I cc
(cicero),
.I cm
(centimeter),
.I dd
(didot point),
.I in
(inch),
.I mm
(millimeter),
.I pc
(pica),
.I pt
(point), or
.I sp
(scaled point), may suffix a number, and the value
will be converted to big points internally.
For convenience, here are conversion tables for
these units:
.PP
.\" NB: Leave blank lines around table header to
.\" prevent their loss from col in the nroff ->
.\" txt/html conversion.
.TS
box center tab(,);
r1| n1 n1 n1 n1 n .

unit,1bp,1cc,1cm,1dd,1in

_,_,_,_,_,_
bp,1,12.7921,28.3465,1.06601,72
cc,0.078173,1,2.21593,0.0833333,5.62846
cm,0.0352778,0.451278,1,0.0376065,2.54
dd,0.938077,12,26.5911,1,67.5415
in,0.0138889,0.177669,0.393701,0.0148057,1
mm,0.352778,4.51278,10,0.376065,25.4
pc,0.0836458,1.07001,2.37106,0.0891674,6.0225
pt,1.00375,12.8401,28.4528,1.07001,72.27
sp,65781.8,841489,1864680,70124.1,4736287
.TE
.PP
.\" NB: Leave blank lines around table header to
.\" prevent their loss from col in the nroff ->
.\" txt/html conversion.
.TS
box center tab(,);
r1| n1 n1 n1 n .

unit,1mm,1pc,1pt,1000000sp

_,_,_,_,_
bp,2.83465,11.9552,0.996264,15.2018
cc,0.221593,0.934572,0.077881,1.18837
cm,0.1,0.421752,0.035146,0.536285
dd,2.65911,11.2149,0.934572,14.2604
in,0.0393701,0.166044,0.013837,0.211136
mm,1,4.21752,0.35146,5.36285
pc,0.237106,1,0.0833333,1.27157
pt,2.84528,12,1,15.2588
sp,186468,786432,65536,1000000
.TE
.PP
Letter case is
.I significant
in option names and dimension units.
.PP
Several options may be assigned lists of items.
List items must be separated by any single
character other than a letter, digits, plus,
minus, or period.  However, multiple spaces are
reduced to single spaces before extracting list
items.  Comma or slash is a readable choice for a
separator character, and avoids the need to quote
the values to protect them from possible shell
interpretation.
.\"-----------------------------------------------
.SS "Color"
The options
.BI "BG" =color-value,
.BI "FG" =color-value,
.BI "FRAMEFG" =color-value,
.BI "IDBG" =color-value,
.BI "IDFG" =color-value,
and
.BI "PAGEBG" =color-value
provide for setting the color of the BoundingBox
background
.RB ( BG )
and foreground
.RB ( FG ),
the frame foreground
.RB ( FRAMEFG ),
the identifying label background
.RB ( IDBG )
and foreground
.RB ( IDFG ),
and the page background
.RB ( PAGEBG ).
.PP
Color values can be provided in several different
color models, set by the
.BI COLORMODEL "=[CMYK\||\|GRAY\||\|HSB\||\|RGB\||\|X]"
option.  In most cases,
.B epsutil
can guess the color model from the syntax of the
color value, so that the
.B COLORMODEL
option rarely needs to be set.
.PP
A color can be specified as:
.RS
.TP \w'\(bu'u+1n
\(bu
a color name (e.g.
.IR red ,
.IR green ,
.IR blue ,
.IR skyblue ,
.IR bisque ", .\|.\|.)"
[letter case is
.I not
significant];
.TP
\(bu
a hexadecimal color (e.g.
.IR #3af ,
.IR #33aaff ,
.IR #333aaafff ,
.IR #3333aaaaffff )
in the X Window System
.I RGB
model;
.TP
\(bu
a triple of numbers, each in the range 0\|.\|.\|1,
for the
.I RGB
and
.I HSB
models;
.TP
\(bu
a quadruple of numbers, each in the range
0\|.\|.\|1, for the
.I CMYK
model;
.TP
\(bu
a single number in the range 0\|.\|.\|1 for the
.I GRAY
model.
.RE
.PP
Color names are looked up in the file specified
by the
.BI RGBFILE =rgbfile
option, or, if that is not given, in the X
Window System
.I rgb.txt
color mapping file. These files associate red,
green, and blue intensities with color names;
their lines contain three numbers in the range
0\|.\|.\|255, followed by a color name, separated
by whitespace.  The
.I rgb.txt
file is found by searching a built-in directory
path that covers all major UNIX systems; that path
can be overridden by defining a value for the
environment variable
.BR RGBPATH .
For example, on an IBM RS/6000 AIX system, you
could set that variable to
.I /usr/lpp/X11/lib/X11/It_IT
in order to get Italian color names.
.PP
Hexadecimal colors in the X Window System color
model specify red, green, and blue intensities on
a scale of 0\|.\|.\|15 (3 hexadecimal digits),
0\|.\|.\|255 (6 hexadecimal digits), 0\|.\|.\|4095 (9
hexadecimal digits), or 0\|.\|.\|65536 (12
hexadecimal digits).  Thus,
.I #3cf
corresponds to 3/15 red, 12/15 green, and 15/15
blue, that is, 0.2 red, 0.8 green, and 1.0 blue.
.PP
In the
.I RGB
model, three numbers in the range 0\|.\|.\|1
define red, green, and blue intensities.  In this
model, major colors are:
.TS
center tab(,);
l r r r| l r r r .
Black,0,0,0,Blue,0,0,1
Red,1,0,0,Magenta,1,0,1
Green,0,1,0,Cyan,0,1,1
Yellow,1,1,0,White,1,1,1
.TE
.PP
Like the
.I RGB
model, the
.I HSB
(hue, saturation, brightness) model also has three
numbers in the range 0\|.\|.\|1.  Hue runs through
the rainbow (approximately, red = 0, orange = 0.1,
limegreen = 0.2, green = 0.3, cyan = 0.5, blue =
0.6, magenta = 0.8, deeppink = 0.9, red =
1). Saturation goes from 0 (no color = black) to 1
(full color).  Brightness goes from 0 (dark) to 1
(bright).  The
.I HSB
model is the only one for which
.B COLORMODEL
.I must
be defined, because
.B epsutil
otherwise assumes a default
.I RGB
model, and other models can be determined from
context.
.PP
The color printing-industry standard
.I CMYK
(cyan, magenta, yellow, black) model requires four
numbers in the range 0\|.\|.\|1.  The first three
are values for cyan, magenta, and yellow (0 means
no color, 1 means full color). The fourth value is
the amount of black (0 means none, 1 means
completely black) to be added to darken the color.
.PP
Finally, in the
.I GRAY
model, a single number in the range 0\|.\|.\|1
defines the amount of gray: 0 is black and 1 is
white.
A value of
.I g
in the
.I GRAY
model is equivalent to
.I g,g,g
in the
.I RGB
model.
.PP
Sample options:
.RS
.nf
.BI FG =HotPink4
.BI BG "=0.9 (GRAY assumed)"
.BI PAGEBG "=1,1,0 (RGB assumed)"
.BI RGBFILE =mycolors.rgb
.BI IDBG "=#7ed (X assumed)"
.BI COLORMODEL =HSB  "   BG" =0.6,0.8,0.9
.BI FG "=0.5,1,0.8,0.7 (CMYK assumed)"
.fi
.RE
.\"-----------------------------------------------
.SS "BoundingBox"
Encapsulated \*(Ps\& files are required to contain
a
.I %%BoundingBox
comment that defines the lower-left and
upper-right corner coordinates in big points.
Sadly, most \*(Ps\&-producing programs produce
(sometimes wildly) incorrect coordinate values in
this comment, so manual adjustment is frequently
necessary.  Also, sometimes only a portion of the
original figure is required, necessitating
definition of a new BoundingBox.
.PP
To avoid the need for modifying the original
\*(Ps\& file, the two corner coordinate pairs can
be specified as four optionally-dimensioned
numbers for the value of the
.B BOUNDINGBOX
option.  Values specified this way override those
in the
.I %%BoundingBox
comment.
.PP
When a
.B BOUNDINGBOX
value is given, especially if it covers only a
portion of the original figure, clipping should be
selected.  See the
.B CLIP
option description following.
.PP
Although fractional dimensions are accepted, after
converting to big points, the values actually used
will be rounded down to the nearest integer at the
lower-left corner, and up to the nearest integer
at the upper-right corner.  This is a requirement
of the
.IR "\*(Ps\& Document Structuring Conventions" .
.PP
Sample options:
.RS
.nf
.BI BOUNDINGBOX =10,20,500,750
.BI BOUNDINGBOX "='10 20 500 750'"
.BI BOUNDINGBOX =0.1in,0.3in,18cm,25cm
.BI BOUNDINGBOX =10mm/20mm/30pc/40pc
.fi
.RE
.\"-----------------------------------------------
.SS "BoundingBox frame"
A rectangular frame of a specified line thickness
will be drawn around the
.I outside
of the original BoundingBox if the
.BI FRAME =frame-thickness
option is given.
.PP
If linewidth scaling is requested, the frame will
also be affected by the scaling.
.PP
The output BoundingBox will automatically be
enlarged by the twice the frame thickness, and any
.B MAXLINEWIDTH
value will be adjusted upward if necessary to
ensure that the frame can be drawn properly.
.PP
Sample options:
.RS
.nf
.BI FRAME =3
.BI FRAME =3mm
.fi
.RE
.\"-----------------------------------------------
.SS "Checking for non-EPSF operators"
If a non-zero value of the
.BI CHECK =check
option is given, check for the presence of \*(Ps\&
operators that are not permitted in EPS files.
This check is not guaranteed to succeed; see the
.B BUGS
section later for why.
.PP
Because this option requires additional pattern
matching on every input line, and is only
occasionally needed, the default is
.BI CHECK =0
to suppress the check.
.PP
Sample options:
.RS
.nf
.BI CHECK =0
.BI CHECK =1
.fi
.RE
.\"-----------------------------------------------
.SS "Clipping"
If a zero value of the
.BI CLIP =clip
option is given, suppress clipping the figure to
the BoundingBox.
.PP
Although EPS-including programs are supposed to
provide this clipping automatically, not all do
so.  Thus, the default in this program is to turn
on clipping.
.PP
The clipping path is set after geometric
transformations have been completed, but before
any drawing operations are performed.  Thus, the
BoundingBox frame, and the background color, are
subject to clipping.
.PP
Sample options:
.RS
.nf
.BI CLIP =0
.BI CLIP =1
.fi
.RE
.\"-----------------------------------------------
.SS "Grid"
A non-zero value for the
.BI GRID =grid
option requests that a grid be drawn over the
picture to allow convenient determination of
BoundingBox coordinates for a portion of the view.
.PP
The grid is always drawn after the image, so that
it cannot be overwritten by it.
.PP
The default grid is in standard \&\*(Ps\& units of
.IR "big points" ,
and is matched to the selected paper size, leaving
a small margin near the page edges where most
\&\*(Ps\& printers are incapable of printing.
.PP
For greater control, you can specify suitable
values for the
.B GRIDX
and
.B GRIDY
options.  These each take the form of a list of up
to
.I ten
items:
.IR "minimum number" ,
.IR "numbering stepsize" ,
.IR "maximum number" ,
.IR "dimension unit name" ,
.IR "grid stepsize" ,
.IR "tick stepsize" ,
.IR "tick length" ,
.IR "thickening multiple" ,
.IR "font size" ,
and
.IR "font name" .
List items can be omitted, in which case internal
defaults corresponding to the selected paper type
will be supplied; see the
.B "Paper type"
section later.  As with ordinary coordinate
values, an omitted dimension on a number defaults
to big points.
.PP
The default setting for the horizontal axis on
American standard
.IR A -format
letter paper is
.BI GRIDX "=50bp,25bp,575bp,bp,25bp,5bp,5bp,100bp,9bp,Helvetica."
This means that the axis will run from 50bp in
steps of 25bp to 575bp, using units of big points,
with grid lines every 25bp, tick marks 5bp long
every 5bp, grid lines thickened at multiples of
100bp, with text in a 9bp-Helvetica font.  Thus,
the axis will be numbered 25, 75, 100, .\|.\|.\|,
550, 575, with grid lines drawn at the numbers,
and 5 tick intervals between each pair of grid
lines.  If the eighth value were changed from
100bp to 0bp, then grid line thickening would be
suppressed.
.PP
Sample options:
.RS
.nf
.BI GRID =0
.BI GRID =1
.PP
.BI GRIDX =,\|,\|,\|,\|,\|,\|,100bp
.BI GRIDX =,\|,\|,\|,\|,\|,\|,\|,18bp,Times-Bold
.BI GRIDX =50bp,25bp,575bp,bp
.BI GRIDX =0bp,50bp,600bp,bp,5bp,5bp,5bp,100bp,9bp,Palatino-BoldItalic
.BI GRIDY =0cm@1cm@25cm@cm@1cm@1mm@@5cm
.BI GRIDY =0in,1in,11in,in
.BI GRIDY =0in:1in:11in:in
.BI GRIDY =0/50/700
.fi
.RE
.\"-----------------------------------------------
.SS "Identifying label"
When working with large numbers of figures, or
experimenting with various options, it is
sometimes difficult to keep track of them.  The
.B ID
option can be specified to provide a page location
where an identifying label recording the command
line will be printed.
.PP
The label location is measured on the output page,
relative to the lower-left corner, independent of
geometric transformations.  The label is drawn
after the image and the grid, in a shaded box
which hides what lies under it.
.PP
An optional third value defines the font size
(default:
.IR 24bp ),
and an optional fourth value defines the font name
(default:
.IR  Helvetica-Bold ).
.PP
The font size is automatically reduced to fit a
long label into the available space, so that it
will always be completely visible.
.PP
For convenience, the special assignment
.BI ID =1
will produce a label in a default position,
near the top of the page.
.PP
Sample options:
.RS
.nf
.BI ID =1
.BI ID =50,750
.BI ID =0.4in/0.4in/12pt
.BI ID "='10mm 10mm 8pt Helvetica-Narrow'"
.fi
.RE
.\"-----------------------------------------------
.SS "Linewidth control"
Sometimes, linewidths need adjustment, usually to
thicken them for better reproduction.  The
.B LINEWIDTHSCALE
value causes all linewidths to be multiplied by
that value.  This scaling also affects any framing
rectangle that is requested.
.PP
\*(Ps\& allows zero linewidths, which means the
thinnest line that the output device is capable of
producing.  Such linewidths would not be affected
by scaling.  Thus, a value for
.B MINLINEWIDTH
can be given to force all lines to be at least
that thick, and therefore, subject to scaling.
.PP
To prevent scaling from producing ridiculously
thick lines, a
.B MAXLINEWIDTH
value can be set to force an upper limit to
linewidths.  If not specified, it defaults to 24.
.PP
If linewidth scaling is applied to a \*(Ps\& file
that already has linewidth scaling, the two
scalings are
.I not
cumulative: only the last scaling applied will
have any effect.  This unfortunate irregularity is
a consequence of the inability of the \*(Ps\&
language to permit redefinition of an operator to
more than one level; attempts to do otherwise
simply produce infinite loops in the \*(Ps\&
interpreter.
.PP
Sample options:
.RS
.nf
.BI LINEWIDTHSCALE =3
.BI MAXLINEWIDTH =6
.BI MAXLINEWIDTH =6bp
.BI MINLINEWIDTH =0.1pt
.fi
.RE
.\"-----------------------------------------------
.SS "Magnification of page"
To facilitate precise measurement of the
BoundingBox, it can be helpful to magnify the
page.
.PP
The
.BR MX ,
.BR MY ,
and
.B MXY
options define magnification factors which are
applied
.I after
page translation, and
.I before
all other transformations.
.B MX
and
.B MY
are used if provided; otherwise,
.B MXY
is used for both
.I x
and
.I y
scaling.  If none of these is specified, then no
page magnification is done; this is equivalent to
setting
.BR MXY =1.
.PP
The page location about which magnification
is done is
.RB ( PMX , PMY ) ,
or
.RB ( PMXY , PMXY )
if
.B PMX
and
.B PMY
are not provided.  The default page location is
the lower-left corner, (0bp,0bp).
.PP
As a convenience, symbolic coordinates of nine
points of the BoundingBox (four corners, four edge
centers, or box center) may be used for the page
location values: combine a corner/edge/center
designator
.I L
(left),
.I R
(right),
.I B
(bottom),
.I T
(top),
.I C
(center), or alternatively, compass-point names,
with an additional coordinate designator
.I X
or
.I Y
for
.B PMX
and
.BR PMY ,
.PP
.if n \{
.ce 999
.nf
\&\fC
TL        TC        TR     NW         N        NE\&
  ------------------         ------------------  \&
  |                |         |                |  \&
  |                |         |                |  \&
CL|        C       |CR      W|        C       |E \&
  |                |         |                |  \&
  |                |         |                |  \&
  ------------------         ------------------  \&
BL        BC        BR     SW         S        SE\&
\&\fP
.fi
.ce 0
\}
.if t \{
.PS
########################################################################
# Figure 1: shaded boxes showing named points
########################################################################
fillval=0.25
move
[
B2: box "C" ht 1.35 wid 1.8 fill
" TR" at B2.ne ljust
" CR" at B2.e ljust
" BR" at B2.se ljust below
"BC" at B2.s below
"TC" at B2.n above
"BL " at B2.sw rjust  below
"CL " at B2.w rjust
"TL " at B2.nw rjust
]
move ; move ; move
[
B3: box "C" ht 1.35 wid 1.8 fill
" NE" at B3.ne ljust
" E" at B3.e ljust
" SE" at B3.se ljust below
"S" at B3.s below
"N" at B3.n above
"SW " at B3.sw rjust  below
"W " at B3.w rjust
"NW " at B3.nw rjust
]
.sp
.PE
\}
.PP
In the symbolic value, neither the letter order,
nor the letter case, is significant.
.PP
Page magnification does
.I not
affect the BoundingBox coordinates, so it must
.I not
be used for production of final EPS files.
.PP
Sample options:
.RS
.nf
.BI MX =2
.BI MY =0.5
.BI MXY =3
.PP
.BI PMX =100bp
.BI PMY =1cm
.BI PMXY =5cc
.BI PMX =SWX
.BI PMX =BLX
.BI PMX =xtr
.BI PMY =cy
.BI PMY =ney
.BI PMXY =C
.fi
.RE
.\"-----------------------------------------------
.SS "Paper type"
You can alter the default paper type by
specifying a value for the
.B PAPER
option.  The paper types recognized are:
.ne 1i
.\" NB: Leave blank lines around table header to
.\" prevent their loss from col in the nroff ->
.\" txt/html conversion.
.TS
box center tab(,);
l r r| l r r .

Name,Width,Height,Name,Width,Height

_,_,_,_,_,_
A,8.5in,11in,A7L,105mm,74mm
B,11in,17in,A8L,74mm,52mm
C,17in,22in,A9L,52mm,37mm
D,22in,34in,A10L,37mm,26mm
E,34in,44in,B0,1000mm,1414mm
Computer-1411,14in,11in,B1,707mm,1000mm
Legal,8.5in,13in,B2,500mm,707mm
Letter,8.5in,11in,B3,353mm,500mm
US-Legal,8.5in,14in,B4,250mm,353mm
A-L,11in,8.5in,B5,176mm,250mm
Computer-1411-L,11in,14in,B6,125mm,176mm
Legal-L,13in,8.5in,B0L,1414mm,1000mm
Letter-L,11in,8.5in,B1L,1000mm,707mm
US-Legal-L,14in,8.5in,B2L,707mm,500mm
COM10,4.1in,9.5in,B3L,500mm,353mm
DL,110mm,220mm,B4L,353mm,250mm
Executive,7.25in,10.5in,B5L,250mm,176mm
Monarch,3.9in,7.5in,B6L,176mm,125mm
A4Small,210mm,297mm,C0,1294mm,916mm
Ledger,11in,17in,C1,916mm,647mm
LetterSmall,8.5in,11in,C2,647mm,458mm
Note,8.5in,11in,C3,458mm,323mm
A0,841mm,1189mm,C4,323mm,229mm
A1,594mm,841mm,C5,229mm,161mm
A2,420mm,594mm,C6,161mm,114mm
A3,297mm,420mm,Octavo,5in,8in
A4,210mm,297mm,Sixmo,6.5in,8in
A5,148mm,210mm,Quarto,8in,10in
A6,105mm,148mm,Foolscap,8.5in,13in
A7,74mm,105mm,Government-legal,8.5in,13in
A8,52mm,74mm,Folio,8.3in,13in
A9,37mm,52mm,ArchA,9in,12in
A10,26mm,37mm,ArchB,12in,18in
A0L,1189mm,841mm,ArchC,18in,24in
A1L,841mm,594mm,ArchD,24in,36in
A2L,594mm,420mm,ArchE,36in,48in
A3L,420mm,297mm,Flsa,8.5in,13in
A4L,297mm,210mm,Flsb,8.5in,13in
A5L,210mm,148mm,HalfLetter,5.5in,8.5in
A6L,148mm,105mm
.TE
.sp
In addition to the standard sizes, any particular
size can be requested by giving it as a list of
.I width
and
.I height
values, for example,
.I 8.5in,11in
or
.IR 210mm/297mm .
.PP
An invalid
.B PAPER
type produces a list of recognized types on
.IR stderr ,
so you can use a nonsense value like
.BI PAPER =helpme
to find out what is available.
.PP
The default paper type is installation dependent:
usually
.I A
(in the USA) or
.I A4
(elsewhere).
.PP
The page dimensions are always defined in the
output \*(Ps\& prolog as
.I PageWidth
and
.IR PageHeight ,
so that other user-defined \*(Ps\& commands can
make use of them.  This is true even if the
.B PAPER
option is not used.
.PP
Besides the page dimensions, the BoundingBox
coordinates are always available for use in
\*(Ps\& as
.IR LLX ,
.IR LLY ,
.IR URX ,
and
.IR URY .
.PP
Sample options:
.RS
.nf
.BI PAPER =148mm/210mm
.BI PAPER =A5
.BI PAPER =B
.BI PAPER =Government-legal
.fi
.RE
.\"-----------------------------------------------
.SS "\*(Ps\& insertions"
Two options,
.B PSCODE
and
.BR PSFILE ,
provide for insertion of additional \*(Ps\& code
into the end of the
.I "%%BeginProlog \&.\|.\|. %%EndProlog"
section where \*(Ps\& commands are defined.
.PP
The value of
.B PSCODE
is a string containing arbitrary literal \*(Ps\&
code.
.PP
The value of
.B PSFILE
is the name of one or more comma- or
space-separated files whose contents are to be
inserted.
.PP
When both options are specified,
.B PSFILE
is handled
.I before
.BR PSCODE ,
so that any \*(Ps\& read from files can be
overridden by literal \*(Ps\& from the command
line.
.PP
For additional power and flexibility, this code
can also optionally redefine one or more
.I hooks :
.IR BeginPageSetupHook ,
.IR EndPageSetupHook ,
.IR BeginDocumentHook ,
.IR EndDocumentHook ,
and
.IR EndJobHook .
These commands are executed at the stages
indicated by their names, allowing \*(Ps\& code to
be effectively inserted at five different places
in the execution stream, without the need for
tedious hand editing.
.PP
The inserted \*(Ps\&, including the hooks,
is executed with a private dictionary,
.IR EPSutilDict ,
at the top of the dictionary stack.  This
dictionary is large (1000 elements), so that it is
highly unlikely that dictionary overflow can
occur.  In any event, this could be a problem only
with older \*(Ps\& devices, since Level 2 \*(Ps\&,
which automatically enlarges dictionaries as
needed, dates from 1990, and most \*(Ps\& devices
manufactured since then fully support it.
.PP
If you define hooks in private packages of
macros, you will soon encounter the need for
extending an existing hook.  If each package
just does something like
.RS
.I "/EndJobHook { .\|.\|. code .\|.\|. } def"
.RE
then only the last-loaded hook definition will
survive.  Fortunately, there is a solution to this
problem which works for \*(Ps\& Version 38 and
later (Level 1 \*(Ps\& implementations from the
late 1980s, and all Level 2 \*(Ps\&
implementations):
.RS
.I "/EndJobHook { //EndJobHook exec  .\|.\|.\|more code\|.\|.\|. } def"
.RE
You could also write this as
.RS
.I "/EndJobHook {  .\|.\|.\|more code\|.\|.\|.  //EndJobHook exec } def"
.RE
if you wanted the new hook code to be added
.I before
the old hook code.  The double slash in
.I //EndJobHook
asks for immediate evaluation of the name.  This
immediately replaces the name by its definition (a
procedure) within the new definition of the hook.
When the new definition is executed, the
.I exec
operator will execute that procedure, effectively
inserting the old definition at the beginning of
the new one.  Without the
.IR exec ,
the procedure would just be left as an unused
object on the execution stack.  I know of no way
to accomplish this without the Version 38 and
later
.I //
immediate-execution feature.
.PP
The facility provided by these options is very
powerful, since arbitrary extra \*(Ps\& code can
be inserted, and \*(Ps\& operators can even be
redefined.
.PP
Sample options:
.RS
Disable region fill permanently:
.nf
.BI PSCODE "='/fill { } def'"
.fi
.PP
Disable region fill only for its first invocation,
thereby removing an initial region fill that some
\*(Ps\&-producing programs always provide:
.nf
.BI PSCODE "='/oldfill /fill load def"
.I "    /fill { /fill /oldfill load def } def'"
.fi
.PP
Supply a copyright claim in the bottom right
margin of the BoundingBox:
.nf
.BI PSCODE "='/EndJobHook { /Helvetica findfont 6 scalefont setfont"
.I "    (Copyright, International Widget Corporation (2001) )"
.I "    dup stringwidth pop URX exch sub LLY 4 add moveto show } def'"
.fi
.PP
Change all solid lines and dashed lines to dashed
lines with a fixed dash pattern:
.nf
.BI PSCODE "='/BeginDocumentHook { [3] 0 setdash /setdash { pop pop } def } def'"
.fi
.PP
Disable rectangle fill:
.nf
.BI PSCODE "='/rectfill { pop pop pop pop } def'"
.fi
.PP
Color the page light blue:
.nf
.BI PSCODE "='gsave 0.7 0.7 1 setrgbcolor 0 0 PageWidth PageHeight rectfill grestore'"
.fi
These commands are equivalent to
.BI COLORMODEL "=RGB"
.BI PAGEBG "=0.7,0.7,1."
.PP
Set the default foreground color to blue:
.nf
.BI PSCODE "='0 0 1 setrgbcolor'
.fi
.PP
Change all colors to shades of gray, assuming that
the \*(Ps\& file uses only the
.I RGB
color model:
.nf
.BI PSCODE "='/setrgbcolor {add add 3 div setgray} bind def'"
.fi
.PP
Fill the background with a blue color ramp, darker
at the bottom, lighter at the top (a popular
choice for overhead transparencies and slides):
.nf
.BI PSCODE "='gsave"
.I "    /delta 0.005 def"
.I "    0.0 delta 1"
.I "    {"
.I "       /f exch def"
.I "       /g 0.6 dup 1 exch sub f mul add def"
.I "       0.9 g mul 0.9 g mul 1 g mul setrgbcolor"
.I "       0 PageHeight f mul PageWidth PageHeight delta mul rectfill"
.I "    } for"
.I "grestore'"
.fi
.PP
Suppress fills 1, 2, 4, and 7:
.nf
.BI PSCODE "='/BeginDocumentHook {"
.I "  /IgnoreFill [ 1 2 4 7 ] def"
.I "  /oldfill /fill load def"
.I "  /FillCount 1 def"
.I "  /fill {"
.I "    /DoFill true def"
.I "    0 1 IgnoreFill length 1 sub"
.I "    {"
.I "      IgnoreFill exch get FillCount eq { /DoFill false def } if"
.I "    } for"
.I "    /FillCount FillCount 1 add def"
.I "    DoFill { oldfill } if"
.I "  } def"
.I "} def'"
.fi
This example is complex enough that some
explanation is in order.  The
.I IgnoreFill
vector contains a list of fill counts at which
filling is to be suppressed.  Each time
.I fill
is invoked, the
.I for
loop iterates over this list, and sets the
.I DoFill
flag to
.I false
if the current fill count is in the list.  At the
end of the loop,
.I FillCount
is incremented by one, and the original fill
command is executed if
.I DoFill
is still
.IR true .
Even without understanding the details, you can
easily modify the code by changing the
.I IgnoreFill
list entries to select any particular fill
operations that you want to suppress.  This can be
useful for removing unwanted background fills
produced by some programs.  Given the common use
by many programs of inscrutable collections of
private \*(Ps\& macros, direct modification of the
original \*(Ps\& code to accomplish the same goal
would likely be humanly infeasible.
.PP
For more extensive modifications:
.nf
.BI PSFILE =mymacros.eps
.BI PSFILE "=header1.eps,../tools/monochrome.eps"
.fi
.RE
.\"-----------------------------------------------
.SS "Rotation"
The
.B ROTATE
option value is a rotation angle in degrees,
positive counterclockwise, and negative clockwise.
Only multiples of +/-90 degrees, or values less
than 90 degrees in absolute value, are supported.
Non-conforming values will elicit a warning and be
ignored, preventing any rotation.
.PP
For example, to turn landscape orientation with
the right side at the top of the page into
portrait orientation, specify
.BI ROTATE =-90.
It will usually be necessary to supply additional
scaling
.RB ( HEIGHT
or
.BR WIDTH ,
or
.BR SX ,
.BR SY ,
or
.B SXY
options) to make the picture fit on the output
page.
.PP
Unless otherwise specified by the translation
variables described later, the position of the
lower-left corner of the BoundingBox on the output
display device is kept invariant, so that after a
-90-degree rotation, the lower-right corner of the
original BoundingBox will be positioned where the
lower-left corner was.
.PP
Small rotation angles can be useful for correcting
the orientation of slightly-rotated scanned
images, since it is often difficult to align
precisely an original document on the scanner
glass.  The output file then contains a comment of
the form
.I "%%RotatedBoundingBox: 71 363 229 522
giving coordinates of a new BoundingBox that may
be suitable for use in a subsequent invocation of
.BR epsutil ,
.I provided
that no further transformations are made.  That
comment is also printed on
.IR stderr .
.if t \{
Here are some sample rotations; notice that the
page position of the lower-left corner of the
original image is always occupied by an image
corner after the rotation.
.PS
########################################################################
# Figure 2: -90 degree rotation
########################################################################

aw		= 0.3			# arrowhead width
boxht		= 1.1			# page height (11in)
boxwd		= 0.85			# page width (8.5in)
f		= 0.55			# (image width)/(page width)
fillimage	= 0.10			# light image
fillpage	= 0.25			# dark page
fillval		= fillpage		# default fill
g		= 0.5			# (image height)/(page height)
marginwidth	= ((1 - f)/2) * boxwd	# left and right margin width
margindepth	= ((1 - g)/2) * boxht	# bottom and top margin depth

A: box fill
{
    move left A.wid
    move right marginwidth
    fillval = fillimage
    C: box wid f * A.wid height g * A.ht fill
    fillval = fillpage
    move left 0.5 * C.wid
    move down 0.5 * C.ht
    arrow up C.ht width aw
}
move right 0.1 ; arrow right 1.2 "ROTATE=-90" "ROTATE=+270" ; move right 0.1
B: box fill
{
    move left A.wid
    move right marginwidth
    move down 0.5 * B.ht
    move up margindepth
    move up 0.5 * C.wid
    right
    {
      fillval = fillimage
      C: box wid g * A.ht height f * A.wid fill
      fillval = fillpage
    }
    arrow right C.wid width aw
}
.PE
.\"-----------------------------------------------
.PP
.PS
########################################################################
# Figure 3: +90 degree rotation
########################################################################

aw		= 0.3			# arrowhead width
boxht		= 1.1			# page height (11in)
boxwd		= 0.85			# page width (8.5in)
f		= 0.55			# (image width)/(page width)
fillimage	= 0.10			# light image
fillpage	= 0.25			# dark page
fillval		= fillpage		# default fill
g		= 0.5			# (image height)/(page height)
marginwidth	= ((1 - f)/2) * boxwd	# left and right margin width
margindepth	= ((1 - g)/2) * boxht	# bottom and top margin depth

A: box fill
{
    move left A.wid
    move right marginwidth
    fillval = fillimage
    C: box wid f * A.wid height g * A.ht fill
    fillval = fillpage
    move left 0.5 * C.wid
    move down 0.5 * C.ht
    arrow up C.ht width aw
}
move right 0.1 ; arrow right 1.2 "ROTATE=+90" "ROTATE=-270" ; move right 0.1
B: box fill
{
    move left A.wid
    move right marginwidth
    move down 0.5 * B.ht
    move up margindepth
    move up 0.5 * C.wid
    right
    fillval = fillimage
    C: box wid g * A.ht height f * A.wid fill
    fillval = fillpage
    arrow left C.wid width aw
}
.PE
.\"-----------------------------------------------
.PP
.PS
########################################################################
# Figure 4: +180 degree rotation
########################################################################

aw		= 0.3			# arrowhead width
boxht		= 1.1			# page height (11in)
boxwd		= 0.85			# page width (8.5in)
f		= 0.55			# (image width)/(page width)
fillimage	= 0.10			# light image
fillpage	= 0.25			# dark page
fillval		= fillpage		# default fill
g		= 0.5			# (image height)/(page height)
marginwidth	= ((1 - f)/2) * boxwd	# left and right margin width
margindepth	= ((1 - g)/2) * boxht	# bottom and top margin depth

A: box fill
{
    move left A.wid
    move right marginwidth
    fillval = fillimage
    C: box wid f * A.wid height g * A.ht fill
    fillval = fillpage
    move left 0.5 * C.wid
    move down 0.5 * C.ht
    arrow up C.ht width aw
}
move right 0.1 ; arrow right 1.2 "ROTATE=+180" "ROTATE=-180" ; move right 0.1
B: box fill
{
    move left A.wid
    move right marginwidth
    fillval = fillimage
    C: box wid f * A.wid height g * A.ht fill
    fillval = fillpage
    move left 0.5 * C.wid
    move up 0.5 * C.ht
    arrow down C.ht width aw
}
.PE
.\"-----------------------------------------------
.PP
.PS
########################################################################
# Figure 5: -6 degree rotation
########################################################################

aw		= 0.3			# arrowhead width
boxht		= 1.1			# page height (11in)
boxwd		= 0.85			# page width (8.5in)

# For reasons that I don't understand, anything bigger for f moves the
# original box right, sigh..., even though there the image remains
# inside the page box.  Changing the rotation angle has no effect.
f		= 0.55			# (image width)/(page width)
fillimage	= 0.10			# light image
fillpage	= 0.25			# dark page
fillval		= fillpage		# default fill
g		= 0.5			# (image height)/(page height)
marginwidth	= ((1 - f)/2) * boxwd	# left and right margin width
margindepth	= ((1 - g)/2) * boxht	# bottom and top margin depth

A: box fill
degrees		= -6
theta		= -3.141592653589793238462643 * (degrees / 180.0)
{
    move left A.wid
    move right marginwidth
    # move left f * A.wid * sin(theta)
    right

    fillval = fillimage
        C: box width f * A.wid height g * A.ht invis
	move to C.sw
	line by (f * A.wid*cos(theta),f * A.wid*sin(theta))
	line by (-g * A.ht*sin(theta),g * A.ht*cos(theta))
	line by (-f * A.wid*cos(theta),-f * A.wid*sin(theta))
	line to C.sw
    fillval = fillpage

    move left 0.5 * f * A.wid
    move down 0.5 * g * A.ht
    arrow from C.sw + (0.5*C.wid*cos(theta),0.5*C.wid*sin(theta)) \
	to C.sw + (0.5*C.wid*cos(theta) - C.ht*sin(theta),\
	           0.5*C.wid*sin(theta) + C.ht*cos(theta)) width aw
}
move right 0.1
arrow right 1.2 sprintf("ROTATE=%g",degrees) ""
move right 0.1
B: box fill
{
    move left A.wid
    move right marginwidth
    fillval = fillimage
    C: box wid f * A.wid height g * A.ht fill
    fillval = fillpage
    move left 0.5 * C.wid
    move down 0.5 * C.ht
    arrow up C.ht width aw
}
.PE
.\"-----------------------------------------------
.PP
.PS
########################################################################
# Figure 6: +8 degree rotation
########################################################################

aw		= 0.3			# arrowhead width
boxht		= 1.1			# page height (11in)
boxwd		= 0.85			# page width (8.5in)

# For reasons that I don't understand, anything bigger for f moves the
# original box right, sigh..., even though there the image remains
# inside the page box.  Changing the rotation angle has no effect.
f		= 0.55			# (image width)/(page width)

fillimage	= 0.10			# light image
fillpage	= 0.25			# dark page
fillval		= fillpage		# default fill
g		= 0.5			# (image height)/(page height)
marginwidth	= ((1 - f)/2) * boxwd	# left and right margin width
margindepth	= ((1 - g)/2) * boxht	# bottom and top margin depth

A: box fill
degrees		= 8
theta		= -3.141592653589793238462643 * (degrees / 180.0)
{
    move left A.wid
    move right marginwidth
    # move left f * A.wid * sin(theta)
    right

    fillval = fillimage
        C: box width f * A.wid height g * A.ht invis
	move to C.sw
	line by (f * A.wid*cos(theta),f * A.wid*sin(theta))
	line by (-g * A.ht*sin(theta),g * A.ht*cos(theta))
	line by (-f * A.wid*cos(theta),-f * A.wid*sin(theta))
	line to C.sw
    fillval = fillpage

    move left 0.5 * f * A.wid
    move down 0.5 * g * A.ht
    arrow from C.sw + (0.5*C.wid*cos(theta),0.5*C.wid*sin(theta)) \
	to C.sw + (0.5*C.wid*cos(theta) - C.ht*sin(theta),\
	           0.5*C.wid*sin(theta) + C.ht*cos(theta)) width aw
}
move right 0.1
arrow right 1.2 sprintf("ROTATE=%g",degrees) ""
move right 0.1
B: box fill
{
    move left A.wid
    move right marginwidth
    fillval = fillimage
    C: box wid f * A.wid height g * A.ht fill
    fillval = fillpage
    move left 0.5 * C.wid
    move down 0.5 * C.ht
    arrow up C.ht width aw
}
.PE
.\"-----------------------------------------------
.PP
\}
.PP
Sample options:
.RS
.nf
.BI ROTATE =0
.BI ROTATE =-90
.BI ROTATE =90
.BI ROTATE =180
.BI ROTATE =270
.BI ROTATE =360
.BI ROTATE =450
.BI ROTATE =-2
.BI ROTATE =3.5
.fi
.RE
.\"-----------------------------------------------
.SS "Translation of BoundingBox"
The origin option variables move the lower-left
corner of the BoundingBox to
.RB ( OX , OY ),
relative to the lower-left page corner,
or if
.B OX
and
.B OY
are not specified, then to
.RB ( OXY , OXY ).
Otherwise, the lower-left corner of the new
BoundingBox will be at the same physical
page location as one of the corners of the
original picture; which one depends on the
rotation angle chosen.
.PP
Sample options:
.RS
.nf
.BI OX =0
.BI OY =0
.BI OX =10mm
.BI OY =36bp
.BI OXY =1in
.BI OXY =3pc
.fi
.RE
.\"-----------------------------------------------
.SS "Translation of page"
The lower-left corner of the page is normally at
(0bp,0bp).  The page translation variables move
that corner to
.RB ( PTX , PTY ),
or if that is not specified, then to
.RB ( PTXY , PTXY ).
.PP
Use this option to move a figure, and any overlaid
grid, away from the page edges where most
\&\*(Ps\& printers are incapable of printing.
.PP
This option does
.I not
affect the BoundingBox coordinates, so it must
.I not
be used for production of final EPS files.
.PP
Sample options:
.RS
.nf
.BI PTX =0
.BI PTY =0
.BI PTX =1cm
.BI PTY =36dd
.BI PTXY =1000000sp
.BI PTXY =3cc
.fi
.RE
.\"-----------------------------------------------
.SS "Scaling (absolute)"
The
.BI HEIGHT =height
and
.BI WIDTH =width
options provide a way to request absolute scaling
of the BoundingBox to a specified height or width.
If only one of them is given, then the other is
computed to preserve the aspect ratio for
distortion-free scaling.  If both are given, then
the horizontal and vertical scale factors may be
different; the aspect ratio will then not be
preserved.
.PP
The two sizes refer to the final figure,
.I after
any rotation.
.PP
If both absolute
.RB ( HEIGHT
and
.BR WIDTH )
and relative
.RB ( SX ,
.BR SY ,
and
.BR SXY )
scaling are specified, then absolute scaling is
done, and the relative scale factors are ignored.
.PP
Sample options:
.RS
.nf
.BI HEIGHT =400bp
.BI HEIGHT =15cm
.BI WIDTH  =340
.BI WIDTH  =150mm
.fi
.RE
.\"-----------------------------------------------
.SS "Scaling (relative)"
The
.BR SX ,
.BR SY ,
and
.B SXY
options provide for relative
scaling.  Any scale factors provided are applied
.I after
the rotation, so that they apply to the
final figure.
.B SX
and
.B SY
are used if provided; otherwise,
.B SXY
is used for both
.I x
and
.I y
scaling if provided.
.PP
Sample options:
.RS
.nf
.BI SX =0.5
.BI SY =2.0
.BI SXY =0.7727
.fi
.RE
.\"===============================================
.SH "HAND MODIFICATION"
The output file can be easily modified by hand
later to adjust any of the options that can be set
on the command line, even if you are unfamiliar
with the \*(Ps\& language.  Look for the lines
following the first
.I %%BeginProlog
comment that begin
.IR "/NAME \&.\|.\|. def" ,
and then change the alphanumeric values as needed.
Comment lines preceding each set of related
variable definitions provide suitable
documentation.
.\"===============================================
.SH BUGS
Until a valid
.I %%BoundingBox
comment has been located, or a
.B BOUNDINGBOX
command-line option has been supplied, the input
\*(Ps\& is buffered in memory.  On small machines,
or with very large \*(Ps\& files that contain the
.I %%Bounding\%Box
comment near the end instead of near the
beginning, it is possible that your computer
memory (and swap space, if any), might be
exceeded.  The easiest solution for such a problem
is to supply a command-line
.B BOUNDINGBOX
value.  This problem is expected to be exceedingly
rare.
.PP
Encapsulated \*(Ps\& is a subset of standard
\*(Ps\& that excludes approximately twenty
operators whose use can prevent successful
inclusion of a \*(Ps\& file inside another \*(Ps\&
file, usually because those operators would
obviate the use of a local
independently-transformed coordinate system, or
would modify the global state of the \*(Ps\&
environment.  When the output file fails to
conform to the specified transformations, it is
often because of the use of these excluded
operators.  If requested by the
.BI CHECK =1
option,
.B epsutil
looks for those operators, and will raise warnings
when they are seen.  Unfortunately, their apparent
absence does not mean that they are not used,
because \*(Ps\& files can also contain binary,
hexadecimal, and other encodings that can hide
such operators from view.  Thus, the only truly
reliable check is visual examination of the output
of
.B epsutil
with a \*(Ps\& previewer or printer, and its
successful incorporation in other documents, such
as with \*(Te\&
.I \eepsffile
or
.I \especial
commands, or in word processors.
.PP
The
.B ROTATE
support needs further generalization to handle
arbitrary rotation angles.  For now, in some
cases, two passes through
.B epsutil
may be needed.
.\"================================================
.SH "ENVIRONMENT VARIABLES"
.TP \w'RGBPATH'u+2n
RGBPATH
Search path (a colon-separated list of
directories) for the X Window System color
definition file,
.IR rgb.txt .
.\"===============================================
.SH FILES
.TP \w'\fIrgb.txt\fP'u+3n
.I rgb.txt
Color mapping file distributed with the X Window
System.
.\"===============================================
.SH AVAILABILITY
The master source distribution for
.B epsutil
is maintained at the Internet archive location
.IR ftp://ftp.math.utah.edu/pub/misc/index.html#epsutil-2.03
for both anonymous ftp and World-Wide Web access.
The source code is in the public domain, and
copies of the program may be freely distributed
and used for any purpose.
.\"===============================================
.SH "SEE ALSO"
.BR a2ps (1),
.BR dvialw (1),
.BR dvips (1),
.BR enscript (1),
.BR genscript (1),
.BR ghostview (1),
.BR gs (1),
.BR gv (1),
.BR lptops (1),
.BR pageview (1),
.BR plot79 (1),
.BR postscript (7),
.BR psposter (1),
.BR tek2ps (1),
.BR tekalw (1),
.BR transcript (1),
.BR x79ps (1),
.BR xpsview (1).
.\"===============================================
.SH AUTHOR
.nf
Nelson H. F. Beebe
Center for Scientific Computing
University of Utah
Department of Mathematics, 322 INSCC
155 S 1400 E RM 233
Salt Lake City, UT 84112-0090
USA
Email: \fCbeebe@math.utah.edu\fP, \fCbeebe@acm.org\fP,
       \fCbeebe@computer.org\fP, \fCbeebe@ieee.org\fP (Internet)
WWW URL: \fChttp://www.math.utah.edu/~beebe\fP
Telephone: +1 801 581 5254
FAX: +1 801 585 1640, +1 801 581 4148
.fi
.\"===============================================
.\" This is for GNU Emacs file-specific customization:
.\" Local Variables:
.\" fill-column: 50
.\" End:
